function [ output_args ] = ExtractSelfExcitedForces(SectionNumber,freq)
%Function returns Calculate static load coeffcients of the bridge deck
%based on force/roation history

close all
%% Get input files and load data (0 prefix indicates stil air conditions)
%is given
axischeck='T';
    PathName=uigetdir('C:\Users\sigurbaa\OneDrive for Business\Masteroppgave\Fra Vindtunneltesting\Wind tunnel process data','File win on-wind conditions');
    [PathName,FileName] = fileparts(PathName);

    PathName0=uigetdir('C:\Users\sigurbaa\OneDrive for Business\Masteroppgave\Fra Vindtunneltesting\Wind tunnel process data','File with still-air conditions');
    [PathName0,FileName0] = fileparts(PathName0);


FileName=[PathName '\' FileName '\Processed Data ' FileName];
FileName0=[PathName0 '\' FileName0 '\Processed Data ' FileName0];
load(FileName0);

DragFilt0=DragFilt;
LiftFilt0=LiftFilt;
MomentFilt0=MomentFilt;
PosX0=PosX;
PosY0=PosY;
PosT0=PosT;
SteadyTime0=SteadyTime;

load(FileName);
% the air density is taken from non-still air conditions

%% Data fit from two separate measurements
%Choose axis for fitting two motion histories
standarddeviations=[std(PosT),std(PosX),std(PosY)];
[maxstdmotion,axisposition]=max(standarddeviations);
if axisposition==1
    axischeck='T';
elseif axisposition==2
    axischeck='X';
elseif axisposition==3
    axischeck='Y';
else
    axischeck='T';
end

if axischeck=='Y';
    [rR,lags] = xcorr(PosY,PosY0);
elseif axischeck=='X';
    [rR,lags] = xcorr(PosX,PosX0);
elseif axischeck=='T';
    [rR,lags] = xcorr(PosT,PosT0);
else
end
[CorrMotion,Ind] = max(rR);
if lags(Ind)>0;
    DragFilt0=[zeros(1,lags(Ind)),DragFilt0];
    LiftFilt0=[zeros(1,lags(Ind)),LiftFilt0];
    MomentFilt0=[zeros(1,lags(Ind)),MomentFilt0];
    PosY0=[zeros(1,lags(Ind)),PosY0];
    PosX0=[zeros(1,lags(Ind)),PosX0];
    PosT0=[zeros(1,lags(Ind)),PosT0];
else 
    DragFilt0=DragFilt0(-lags(Ind)+1:end);
    LiftFilt0=LiftFilt0(-lags(Ind)+1:end);
    MomentFilt0=MomentFilt0(-lags(Ind)+1:end);
    PosY0=PosY0(-lags(Ind)+1:end);
    PosX0=PosX0(-lags(Ind)+1:end);
    PosT0=PosT0(-lags(Ind)+1:end);
end
endzeros=length(PosY)-length(PosY0);
if endzeros>0; %extend
    DragFilt0=[DragFilt0,zeros(1,endzeros)];
    LiftFilt0=[LiftFilt0,zeros(1,endzeros)];
    MomentFilt0=[MomentFilt0,zeros(1,endzeros)];
    PosX0=[PosX0,zeros(1,endzeros)];
    PosY0=[PosY0,zeros(1,endzeros)];
    PosT0=[PosT0,zeros(1,endzeros)];
else    %shorten
    DragFilt0=DragFilt0(1:length(PosY));
    LiftFilt0=LiftFilt0(1:length(PosY));
    MomentFilt0=MomentFilt0(1:length(PosY));
    PosX0=PosX0(1:length(PosY));
    PosY0=PosY0(1:length(PosY));
    PosT0=PosT0(1:length(PosY));
end

%% Choosing the range of interest
FigureName=['Choose motion history'];
Fig768 = figure('Name',FigureName,'NumberTitle','off');
set(Fig768, 'Position', [50 50 1300 600]);
plot(SteadyTime,PosX,SteadyTime,PosY,SteadyTime,PosT,SteadyTime,PosX0,SteadyTime,PosY0,SteadyTime,PosT0)
legend('PosX','PosY','PosT','PosX0','PosY0','PosT0')
title('Click twice to indicate data range')

[x,y] = ginput(2); %first click for the start and the second for indicating ending data point
DeltaT=SteadyTime(20)-SteadyTime(19);
x=x/DeltaT;   %multiplied with the frequency of acquisition
x=round(x);
close(Fig768);

%Operating on data chosen range
PosX=-0.001.*PosX(x(1):x(2)); PosX0=-0.001*PosX0(x(1):x(2));
PosY=0.001.*PosY(x(1):x(2)); PosY0=0.001.*PosY0(x(1):x(2));
PosT=-(pi/180).*PosT(x(1):x(2)); PosT0=-(pi/180).*PosT0(x(1):x(2));
SteadyTime=SteadyTime(x(1):x(2));
DragFilt=-DragFilt(x(1):x(2)); DragFilt0=-DragFilt0(x(1):x(2));
LiftFilt=LiftFilt(x(1):x(2)); LiftFilt0=LiftFilt0(x(1):x(2));
MomentFilt=-MomentFilt(x(1):x(2)); MomentFilt0=-MomentFilt0(x(1):x(2));

%Find the lag again
if axischeck=='Y';
    [rR,lags] = xcorr(PosY,PosY0,'coeff');
elseif axischeck=='X';
    [rR,lags] = xcorr(PosX,PosX0,'coeff');
elseif axischeck=='T';
    [rR,lags] = xcorr(PosT,PosT0,'coeff');
else
end
lags=lags*DeltaT;
[CorrMotion,Ind] = max(rR);
LagMotion=abs(lags(Ind))*1000; %give value in ms

%% Plot Aerodynamic forces  and motion
AeroDrag=DragFilt-DragFilt0;
AeroLift=LiftFilt-LiftFilt0;
AeroMoment=MomentFilt-MomentFilt0;
plotname=['Wind tunnel ' num2str(V) ' speed'];

FigureName=['Trimmed motion history  and  Aerodynamic forces'];
Fig765 = figure('Name',FigureName,'NumberTitle','off');
set(Fig765, 'Position', [50 50 1300 600]);
subplot(4,1,1)
plot(SteadyTime,PosX,SteadyTime,PosY,SteadyTime,PosT)
legend('PosX','PosY','PosT')
ylabel('Amplitude [cm/degree]')
strval = ['Lag time between signal= ' num2str(LagMotion) ' ms'];
text(mean(SteadyTime),1,strval,'HorizontalAlignment','left');
subplot(4,1,2)
plot(SteadyTime,DragFilt,SteadyTime,DragFilt0,SteadyTime,AeroDrag)
ylabel('Drag [N]')
legend(plotname,'Still-air','Self-excited')
subplot(4,1,3)
plot(SteadyTime,LiftFilt,SteadyTime,LiftFilt0,SteadyTime,AeroLift)
ylabel('Lift [N]')
legend(plotname,'Still-air','Self-excited')
subplot(4,1,4)
plot(SteadyTime,MomentFilt,SteadyTime,MomentFilt0,SteadyTime,AeroMoment)
legend(plotname,'Still-air','Self-excited')
xlabel('Time [s]')
ylabel('Moment [Nm]')

%% Saving the file and data
FigurePath=[PathName 'Self-excited forces ' num2str(V) 'wind spped ' num2str(freq) 'Hz'];
FigFigurePath=[FigurePath '.fig'];
MatSavePath=[FigurePath '.mat'];

plotanswer=1;
WindV=V;
if plotanswer ==1;
    rr(:,1)=PosX;
    rr(:,2)=PosY;
    rr(:,3)=PosT;
    Q(:,1)=AeroDrag;
    Q(:,2)=AeroLift;
    Q(:,3)=AeroMoment;
    savefig(FigFigurePath) %saves the current figure to a FIG-file named filename.fig.
    save(MatSavePath,'SteadyTime','Q','rr','WindV','SectionNumber','PathName','MeanForce');
end
end

